%define major 1
%define libname	%mklibname %{name} %{major}
%define libnamedevel %mklibname %{name} -d
%define libnamestaticdevel %mklibname %{name} -d -s

%define _program_prefix eu-

%ifarch %{sunsparc}
%define	build_check		1
%else
%define build_check		1
%endif
%{expand: %{?_without_CHECK:	%%global build_check 0}}
%{expand: %{?_with_CHECK:	%%global build_check 1}}

%define build_compat		0
%if %{mdkversion} < 1010
%define build_compat		1
%endif
%{expand: %{?_without_COMPAT:	%%global build_compat 0}}
%{expand: %{?_with_COMPAT:	%%global build_compat 1}}

Summary:	A collection of utilities and DSOs to handle compiled objects
Name:		elfutils
Version:	0.131
Release:	%mkrel 2
License:	GPLv2+
Group:		Development/Other
Source0:	ftp://sources.redhat.com/pub/systemtap/elfutils/%{name}-%{version}.tar.bz2
Source1:	testfile16.symtab.bz2
Source2:	testfile16.symtab.debug.bz2
# these 3 patches are from ftp://sources.redhat.com/pub/systemtap/elfutils/ 
Patch0:		elfutils-portability.patch
Patch1:		elfutils-robustify.patch
Patch2:		elfutils-strip-copy-symtab.patch
# mdv patches
Patch3:		elfutils-0.120-fix-sparc-build.patch
Patch4:		elfutils-0.108-align.patch
Patch5:		elfutils-0.123-fix-special-sparc-elf32-plt-entries.patch
Patch6:		gnu_inline.diff
Patch7:		%{name}-0.128-elflint.patch
Patch9:		pointer_cast.diff
Patch10:	readelf_subelf.diff
Patch11:	unaligned.diff
Requires:	%{libname} = %{version}-%{release}
%if %{build_compat}
BuildRequires:	gcc >= 3.2
%else
BuildRequires:	gcc >= 3.4
%endif
BuildRequires:	bison
BuildRequires:	flex
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

%description
Elfutils is a collection of utilities, including:

   * %{_program_prefix}nm: for listing symbols from object files
   * %{_program_prefix}size: for listing the section sizes of an object or archive file
   * %{_program_prefix}strip: for discarding symbols
   * %{_program_prefix}readelf: the see the raw ELF file structures
   * %{_program_prefix}elflint: to check for well-formed ELF files

%package -n	%{libnamedevel}
Summary:	Development libraries to handle compiled objects
Group:		Development/Other
License:	GPL
Requires:	%{libname} = %{version}-%{release}
Provides:	%{name}-devel lib%{name}-devel
Obsoletes:	libelf-devel
Obsoletes:	libelf0-devel
Obsoletes:	%{_lib}%{name}1-devel
Provides:	libelf-devel libelf0-devel

%description -n	%{libnamedevel}
This package contains the headers and dynamic libraries to create
applications for handling compiled objects.

   * libelf allows you to access the internals of the ELF object file
     format, so you can see the different sections of an ELF file.
   * libebl provides some higher-level ELF access functionality.
   * libasm provides a programmable assembler interface.

%package -n	%{libnamestaticdevel}
Summary:	Static libraries for development with libelfutils
Group:		Development/Other
License:	GPL
Requires:	%{libnamedevel} = %{version}-%{release}
Provides:	%{name}-static-devel 
Obsoletes:	libelf-static-devel libelf0-static-devel
Provides:	libelf-static-devel libelf0-static-devel
Obsoletes:	%{_lib}%{name}1-static-devel

%description -n	%{libnamestaticdevel}
This package contains the static libraries to create applications for
handling compiled objects.

%package -n	%{libname}
Summary:	Libraries to read and write ELF files
Group:		System/Libraries
License:	OSL
Provides:	lib%{name}
Obsoletes:	libelf libelf0
Provides:	libelf libelf0

%description -n	%{libname}
This package provides DSOs which allow reading and writing ELF files
on a high level.  Third party programs depend on this package to read
internals of ELF files.  The programs of the elfutils package use it
also to generate new ELF files.

Also included are numerous helper libraries which implement DWARF,
ELF, and machine-specific ELF handling.

%prep
%setup -q
ln -f %{SOURCE1} %{SOURCE2} tests || cp -f %{SOURCE1} %{SOURCE2} tests

%if %{build_compat}
%patch0 -p1 -b .portability
sleep 1
find . \( -name Makefile.in -o -name aclocal.m4 \) -print | xargs touch
sleep 1
find . \( -name configure -o -name config.h.in \) -print | xargs touch
%endif

%patch1 -p1 -b .robustify
%patch2 -p1 -b .strip_copy_symtab
%patch3 -p1 -b .sparc
%patch4 -p1 -b .align
%patch5 -p1 -b .sparc_elf32_plt
%patch6 -p1 -b .inline
%patch7 -p1 -b .erllint
%patch9 -p1 -b .leak
%patch10 -p1 -b .null
%patch11 -p1 -b .unaligned

# Don't use -Werror with -Wformat=2 -std=gnu99 as %a[ won't be caught
# as the GNU %a extension.
perl -pi -e '/AM_CFLAGS =/ and s/-Werror//g' ./tests/Makefile.{in,am}

%build
mkdir build-%{_target_platform}
pushd build-%{_target_platform}
CONFIGURE_TOP=.. \
%configure2_5x \
%{?_program_prefix: --program-prefix=%{_program_prefix}} --enable-shared
%make
popd

%check
%if %{build_check}
pushd build-%{_target_platform}
%make check || :
popd
%endif

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{_prefix}

%makeinstall_std -C build-%{_target_platform}

chmod +x %{buildroot}%{_libdir}/lib*.so*
chmod +x %{buildroot}%{_libdir}/elfutils/lib*.so*

# XXX Nuke unpackaged files
{ cd %{buildroot}
  rm -f .%{_bindir}/eu-ld
  rm -f .%{_bindir}/eu-objdump
  rm -f .%{_includedir}/elfutils/libasm.h
  rm -f .%{_libdir}/libasm-%{version}.so
  rm -f .%{_libdir}/libasm.{a,so}
}

%clean
rm -rf %{buildroot}

%post -n %{libname} -p /sbin/ldconfig
%postun -n %{libname} -p /sbin/ldconfig

%files
%defattr(-,root,root)
%doc NOTES README NEWS TODO
%{_bindir}/eu-addr2line
%{_bindir}/eu-ar
%{_bindir}/eu-elfcmp
%{_bindir}/eu-findtextrel
%{_bindir}/eu-elflint
%{_bindir}/eu-unstrip
%{_bindir}/eu-nm
%{_bindir}/eu-ranlib
%{_bindir}/eu-readelf
%{_bindir}/eu-size
%{_bindir}/eu-strip
%{_bindir}/eu-strings
%{_bindir}/eu-make-debug-archive
%{_libdir}/libdw-%{version}.so
%{_libdir}/libdw*.so.*
%dir %{_libdir}/elfutils
%{_libdir}/elfutils/lib*.so

%files -n %{libnamedevel}
%defattr(-,root,root)
%{_includedir}/dwarf.h
%{_includedir}/libelf.h
%{_includedir}/gelf.h
%{_includedir}/nlist.h
%dir %{_includedir}/elfutils
%{_includedir}/elfutils/elf-knowledge.h
%{_includedir}/elfutils/libebl.h
%{_includedir}/elfutils/libdw.h
%{_includedir}/elfutils/libdwfl.h
%{_libdir}/libelf.so
%{_libdir}/libdw.so

%files -n %{libnamestaticdevel}
%defattr(-,root,root)
%{_libdir}/libebl.a
%{_libdir}/libelf.a
%{_libdir}/libdw.a

%files -n %{libname}
%defattr(-,root,root)
%{_libdir}/libelf-%{version}.so
%{_libdir}/libelf*.so.%{major}*


%changelog
* Sun Feb 10 2008 Tomasz Pawel Gajc <tpg@mandriva.org> 0.131-2mdv2008.1
+ Revision: 164990
- rebuild

* Sun Dec 30 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 0.131-1mdv2008.1
+ Revision: 139413
- add two test files (Source 1 and 2)
- provide updated version of patch 6  (gnu_inline)
- fix mem leak with patch 9
- provide patches 10 and 11 (minor upstream fixes)
- patch 8 has been merged upstream
- drop useles buildrequires on sharutils and libtool-devel (?)
- add buildrequires on bison and flex
- new program: eu-make-debug-archive
- spec file clean
- correct Source0
- new version 0.131
- update upstream patches 0,1,2

  + Olivier Blin <oblin@mandriva.com>
    - restore BuildRoot

  + Thierry Vignaud <tvignaud@mandriva.com>
    - kill re-definition of %%buildroot on Pixel's request

* Sat Jul 14 2007 Tomasz Pawel Gajc <tpg@mandriva.org> 0.128-1mdv2008.0
+ Revision: 52067
- new program: eu-strip
- remove dead entries in spec file
- correct libification
- correct patch order
- provide patch 6 (gnu_inline)
- provide patches 7 and 8 (minor fixes)
- new version 0.128

* Thu Jun 21 2007 Olivier Thauvin <nanardon@mandriva.org> 2mdv2008.0-current
+ Revision: 42294
- don't redefine _gnu to nil
- apply new devel policy

* Fri Jun 08 2007 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 0.127-1mdv2008.0
+ Revision: 37513
- Updated to version 0.127.
- Added updated upstream versions of patches portability and robustify
  (fedora).

* Thu May 03 2007 Per Øyvind Karlsen <pkarlsen@mandriva.com> 0.126-1mdv2008.0
+ Revision: 20819
- new release: 0.126
- sync patches with fedora


* Sat Jan 27 2007 Per Øyvind Karlsen <pkarlsen@mandriva.com> 0.125-2mdv2007.0
+ Revision: 114272
- elfutils should now work on sparc! :)
- support special case of SPARC ELF32 PLT entires (P6 from PLD)
- allocated pointers need 8-byte alignment on sparc (to use ldd/std opcodes to access 8-byte aligned structs) (P5 from PLD)

* Thu Jan 25 2007 Per Øyvind Karlsen <pkarlsen@mandriva.com> 0.125-1mdv2007.1
+ Revision: 113565
- check fails on other archs than sparc too, enable it for all but make failure non-fatal
- reenable check (except for sparc)
- new release: 0.125
- Fix overeager warn_unused_result build failures. (P3 from fedora)
- eu-strip -f: copy symtab into debuginfo file when relocs use it (P4 from fedora, RHBZ #203000)

* Tue Oct 31 2006 Oden Eriksson <oeriksson@mandriva.com> 0.120-3mdv2007.1
+ Revision: 74664
- bunzip patches
- Import elfutils

* Mon May 15 2006 Stefan van der Eijk <stefan@eijk.nu> 0.120-2mdk
- rebuild for sparc

* Wed Apr 19 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 0.120-1mdk
- 0.120
- update robustification patch (P1)
- fix sparc build (P2)
- License has been changed to GPL, except for libraries which is still OSL
- move check to %%check stage
- disable checks on sparc

* Thu Apr 06 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 0.119-2mdk
- add robustification patch (P1) from fedora
- don't give errors on compile warnings on sparc

* Fri Jan 27 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 0.119-1mdk
- 0.119
- %%mkrel

* Wed Dec 28 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.118-1mdk
- 0.118

* Wed Jul 27 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 0.109-1mdk
- 0.109

* Thu Feb 17 2005 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.99-1mdk
- 0.99

* Sun Jan 23 2005 Per Øyvind Karlsen <peroyvind@linux-mandrake.com> 0.97-1mdk
- 0.97
- fix summary-ended-with-dot

* Sat Sep 18 2004 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 0.96-1mdk
- 0.96

